Loading...
Searching...
No Matches
openshot::Expander Class Reference

This class adds a expander (or noise gate) into the audio. More...

`#include <audio_effects/Expander.h>`

Inheritance diagram for openshot::Expander:

## Public Member Functions

float | calculateAttackOrRelease (float value)
| Expander ()
| Default constructor.
| Expander (Keyframe threshold, Keyframe ratio, Keyframe attack, Keyframe release, Keyframe makeup_gain, Keyframe bypass)
| Constructor.
std::shared_ptr< openshot::Frame > | GetFrame (int64_t frame_number) override
| This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.
std::shared_ptr< openshot::Frame > | GetFrame (std::shared_ptr< openshot::Frame > frame, int64_t frame_number) override
| This method is required for all derived classes of ClipBase, and returns a modified openshot::Frame object.
std::string | Json () const override
| Generate JSON string of this object.
Json::Value | JsonValue () const override
| Generate Json::Value for this object.
std::string | PropertiesJSON (int64_t requested_frame) const override
void | SetJson (const std::string value) override
| Load JSON string into this object.
void | SetJsonValue (const Json::Value root) override
| Load Json::Value into this object.
Public Member Functions inherited from openshot::EffectBase
Json::Value | BasePropertiesJSON (int64_t requested_frame) const
| Generate JSON object of base properties (recommended to be used by all effects)
int | constrain (int color_value)
| Constrain a color value from 0 to 255.
void | DisplayInfo (std::ostream *out=&std::cout)
| Display effect information in the standard output stream (stdout)
virtual std::string | GetVisibleObjects (int64_t frame_number) const
| Get the indexes and IDs of all visible objects in the given frame.
void | InitEffectInfo ()
virtual std::string | Json (int64_t requested_frame) const
Json::Value | JsonInfo () const
| Generate JSON object of meta data / info.
int | Order () const
| Get the order that this effect should be executed.
void | Order (int new_order)
| Set the order that this effect should be executed.
openshot::ClipBase * | ParentClip ()
| Parent clip object of this effect (which can be unparented and NULL)
void | ParentClip (openshot::ClipBase *new_clip)
| Set parent clip object of this effect.
std::string | ParentClipId () const
| Return the ID of this effect's parent clip.
virtual void | SetJson (int64_t requested_frame, const std::string value)
void | SetParentEffect (std::string parentEffect_id)
| Set the parent effect from which this properties will be set to.
virtual | ~EffectBase ()=default
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip.
float | Duration () const
| Get the length of this clip (in seconds)
virtual float | End () const
| Get end position (in seconds) of clip (trim end of video)
virtual void | End (float value)
| Set end position (in seconds) of clip (trim end of video)
std::string | Id () const
| Get the Id of this clip object.
void | Id (std::string value)
int | Layer () const
| Get layer of clip on timeline (lower number is covered by higher numbers)
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers)
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
virtual openshot::TimelineBase * | ParentTimeline ()
| Get the associated Timeline pointer (if any)
virtual void | ParentTimeline (openshot::TimelineBase *new_timeline)
| Set associated Timeline pointer.
float | Position () const
| Get position on timeline (in seconds)
void | Position (float value)

> ‍Set the Id of this clip object

float | Start () const
| Get start position (in seconds) of clip (trim start of video)
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video)
virtual | ~ClipBase ()=default

## Public Attributes

Keyframe | attack
Keyframe | bypass
float | control
float | input_level
float | inverse_sample_rate
float | inverseE
Keyframe | makeup_gain
juce::AudioBuffer< float > | mixed_down_input
Keyframe | ratio
Keyframe | release
Keyframe | threshold
float | xg
float | xl
float | yg
float | yl
float | yl_prev
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect.
EffectBase * | parentEffect
| Parent effect (which properties will set this effect properties)
std::map< int, std::shared_ptr< openshot::TrackedObjectBase > > | trackedObjects
| Map of Tracked Object's by their indices (used by Effects that track objects on clips)

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (std::string name, int value, int selected_value) const
| Generate JSON choice for a property (dropdown properties)
Json::Value | add_property_json (std::string name, float value, std::string type, std::string memo, const Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame) const
| Generate JSON for a property.
Protected Attributes inherited from openshot::EffectBase
openshot::ClipBase * | clip
| Pointer to the parent clip instance (if any)
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip)
std::string | id
| ID Property for all derived Clip and Effect classes.
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips.
float | position
| The position on the timeline where this clip should start playing.
std::string | previous_properties
| This string contains the previous JSON properties.
float | start
| The position in seconds to start playing (used to trim the beginning of a clip)
openshot::TimelineBase * | timeline
| Pointer to the parent timeline instance (if any)

## Detailed Description

This class adds a expander (or noise gate) into the audio.

Definition at line 36 of file Expander.h.

## Constructor & Destructor Documentation

## Expander() [1/2]

Expander::Expander | ( |  | ) |

Default constructor.

Definition at line 19 of file Expander.cpp.

## Expander() [2/2]

Expander::Expander | ( | Keyframe | threshold,
|  | Keyframe | ratio,
|  | Keyframe | attack,
|  | Keyframe | release,
|  | Keyframe | makeup_gain,
|  | Keyframe | bypass
| ) |  |

Constructor.

Definition at line 22 of file Expander.cpp.

## Member Function Documentation

## calculateAttackOrRelease()

float Expander::calculateAttackOrRelease | ( | float | value | ) |

Definition at line 113 of file Expander.cpp.

Referenced by GetFrame().

## GetFrame() [1/2]

std::shared_ptr< openshot::Frame > openshot::Expander::GetFrame | ( | int64_t | frame_number | ) |

inline override virtual

This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.

Returns
  A new openshot::Frame object

Parameters

  frame_number | The frame number (starting at 1) of the clip or effect on the timeline.

Implements openshot::ClipBase.

Definition at line 73 of file Expander.h.

Referenced by GetFrame().

## GetFrame() [2/2]

std::shared_ptr< openshot::Frame > Expander::GetFrame | ( | std::shared_ptr< openshot::Frame > | frame,
|  | int64_t | frame_number
| ) |  |

override virtual

This method is required for all derived classes of ClipBase, and returns a modified openshot::Frame object.

The frame object is passed into this method and used as a starting point / background (pixels). All Clip keyframes and effects are resolved into pixels.

Returns
  The modified openshot::Frame object

Parameters

  frame | This is ignored on Clip, due to caching optimizations. This frame instance is clobbered with the source frame.
  frame_number | The frame number (starting at 1) of the clip or effect on the timeline.

Implements openshot::ClipBase.

Definition at line 52 of file Expander.cpp.

## Json()

std::string Expander::Json | ( |  | ) | const

override virtual

Generate JSON string of this object.

Reimplemented from openshot::EffectBase.

Definition at line 122 of file Expander.cpp.

## JsonValue()

Json::Value Expander::JsonValue | ( |  | ) | const

override virtual

Generate Json::Value for this object.

Reimplemented from openshot::EffectBase.

Definition at line 129 of file Expander.cpp.

Referenced by Json().

## PropertiesJSON()

std::string Expander::PropertiesJSON | ( | int64_t | requested_frame | ) | const

override virtual

Get all properties for a specific frame (perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 189 of file Expander.cpp.

## SetJson()

void Expander::SetJson | ( | const std::string | value | ) |

override virtual

Load JSON string into this object.

Reimplemented from openshot::EffectBase.

Definition at line 146 of file Expander.cpp.

## SetJsonValue()

void Expander::SetJsonValue | ( | const Json::Value | root | ) |

override virtual

Load Json::Value into this object.

Reimplemented from openshot::EffectBase.

Definition at line 163 of file Expander.cpp.

Referenced by SetJson().

## Member Data Documentation

## attack

Keyframe openshot::Expander::attack

Definition at line 46 of file Expander.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## bypass

Keyframe openshot::Expander::bypass

Definition at line 49 of file Expander.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## control

float openshot::Expander::control

Definition at line 56 of file Expander.h.

Referenced by GetFrame().

## input_level

float openshot::Expander::input_level

Definition at line 58 of file Expander.h.

Referenced by GetFrame().

## inverse_sample_rate

float openshot::Expander::inverse_sample_rate

Definition at line 61 of file Expander.h.

Referenced by calculateAttackOrRelease(), and GetFrame().

## inverseE

float openshot::Expander::inverseE

Definition at line 62 of file Expander.h.

Referenced by calculateAttackOrRelease(), and GetFrame().

## makeup_gain

Keyframe openshot::Expander::makeup_gain

Definition at line 48 of file Expander.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## mixed_down_input

juce::AudioBuffer<float> openshot::Expander::mixed_down_input

Definition at line 51 of file Expander.h.

Referenced by GetFrame().

## ratio

Keyframe openshot::Expander::ratio

Definition at line 45 of file Expander.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## release

Keyframe openshot::Expander::release

Definition at line 47 of file Expander.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## threshold

Keyframe openshot::Expander::threshold

Definition at line 44 of file Expander.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## xg

float openshot::Expander::xg

Definition at line 54 of file Expander.h.

Referenced by GetFrame().

## xl

float openshot::Expander::xl

Definition at line 52 of file Expander.h.

Referenced by GetFrame().

## yg

float openshot::Expander::yg

Definition at line 55 of file Expander.h.

Referenced by GetFrame().

## yl

float openshot::Expander::yl

Definition at line 53 of file Expander.h.

Referenced by GetFrame().

## yl_prev

float openshot::Expander::yl_prev

Definition at line 59 of file Expander.h.

Referenced by GetFrame().

The documentation for this class was generated from the following files:

- audio_effects/Expander.h
- audio_effects/Expander.cpp